class PathsMapper expands KeyPoint;

var PathsActor G;
var Actor HackedZone;
var Shoot_It Shooter;
var NavigationPoint N1, N2, N3, N4, N5, N6, N7, N8, N9, N10, N11, N12, N13, N14; //Asiggning points to connect

/*
,'Kroogar'
*/

/*
	This Keypoint is not compiled normally due to Navigation tunes requested. This is method for nasty low grav zones.
	Bot attempt to wander randomly blocking those teleporters and wasting time useless.
	KeyPoint Patcher will lock them as much as possible.
	We need also some links which doesn't exist.
	Several combat zones need Teleporters higher or else bot wuill telefrag any pawn - seriously that setup looks EVIL.
	Movers - WTF is here anyway, majority can be open with GRAB command - gimme a break.
	Mover in sniper zones what purpose do has that ? From now on it will open and we can get those dropped weapons
	by boosting up. Combat is balanced, they have Insta, we have Insta LOL.
	Not the last, PrecipitationGenerator sucks - it won't live that much.
*/

//=====
native(1718) final function bool AddToPackageMap( optional string PkgName );
//=====
native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly ); //Second parameter doesn't exist in 227!
//=====
native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P, optional float Distance,
optional vector VOrigin, optional bool bHasPRI, optional Pawn StartAt );
//=====
native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible );
//=====
native(3542) final iterator function InventoryActors( class<Inventory> InvClass,
out Inventory Inv, optional bool bSubclasses, optional Actor StartFrom );
//=====
native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor, float Radius,
optional vector Loc );
//=====
native(3553) final iterator function DynamicActors( class<actor> BaseClass, out actor Actor,
optional name MatchTag );
//=====
native(3560) static final function bool ReplaceFunction( class<Object> ReplaceClass,
class<Object> WithClass, name ReplaceFunction, name WithFunction, optional name InState );
//=====

event PreBeginPlay()
{
	log(Self.name@"Patching Level.",'Kroogar');
	G = Spawn( class'PathsActor' );
	ChangeNastyActors();
	AddMHObjectives();
	DoAlterBadPoints();
	SpawnShoters();
	InitialState='PathsMapping';
	log ("PreBeginPlay Completed...",'Kroogar');
}

event PostBeginPlay()
{
}

final function SpawnShoters()
{
}

function AddMHObjectives()
{
	local class<Actor> Wp;
	local Actor K1, K2, K3, K4, K5, K6, K7, K8, K9, K10, K11, K12, K13;
	local Actor tmp;

	K1 = Spawn(class'PathProtector',,,vect(8016,7040,-90));
	if (K1 != None)
	{
		K1.Tag = 'doorlabo';
	}
	K2 = Spawn(class'PathProtector',,,vect(15126,4248,-300));
	if (K2 != None)
	{
		K2.Tag = 'cavebars200';
	}
}

final function DoAlterBadPoints()
{
	local NavigationPoint A;
	local InventorySpot In;
	local JumpSpot Ju;
	local LiftExit Li;
	local Teleporter Te;
	local PathNode Pa;
	local SpawnPoint Sp;
	local PlayerStart Pl;
	local int I;
	local string st;

	log ("Attempting to screw up some NavigationPoint actors...",'Kroogar');
	if ( G != None )
	{
		foreach NavigationActors(class'InventorySpot',In,30,vect(7073,14302,-347))
		{
			if (string(In.Name) ~= "InventorySpot249")
			{
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I,'Kroogar');
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(8224,14304,-347))
		{
			if (string(In.Name) ~= "InventorySpot248")
			{
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				break;
			}
		}
		foreach NavigationActors(class'PathNode',Pa,30,vect(-576,-4528,-75)) //Get over it, pick that ammo
		{
			if (string(Pa.Name) ~= "PathNode263")
			{
				Pa.bStatic = False;
				Pa.bCollideWorld = False;
				Pa.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(Pa);
				Pa.SetLocation(Pa.Location + vect(0,0,-100));
				Pa.bStatic = True;
				I++;
				log (Pa.Name@"is number"@I,'Kroogar');
				break;
			}
		}
		foreach NavigationActors(class'PathNode',Pa,30,vect(576,-4512,-75))
		{
			if (string(Pa.Name) ~= "PathNode261")
			{
				Pa.bStatic = False;
				Pa.bCollideWorld = False;
				Pa.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(Pa);
				Pa.SetLocation(Pa.Location + vect(0,0,-100));
				Pa.bStatic = True;
				I++;
				log (Pa.Name@"is number"@I,'Kroogar');
				break;
			}
		}
		foreach NavigationActors(class'PathNode',Pa,30,vect(15363,3785,775)) //Useless
		{
			if (string(Pa.Name) ~= "PathNode188")
			{
				Pa.bStatic = False;
				Pa.bCollideWorld = False;
				Pa.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(Pa);
				Pa.SetLocation(Pa.Location + vect(0,0,-100));
				Pa.bStatic = True;
				I++;
				log (Pa.Name@"is number"@I,'Kroogar');
				break;
			}
		}
	}
}

final function DoFakeNavigation()
{
	local RadiusMove RM0, RM1, RM2, RM3, RM4, RM5, RM6, RM7, RM8, RM9, RM10, RM11, RM12, RM13, RM14, RM15,
		RM16, RM17, RM18, RM19, RM20, RM21, RM22, RM23, RM24, RM25;
	local Dispatcher Ds0, Ds1, Ds2;

/*
	RM0 = Spawn(class'RadiusMove',,,vect(-16,2824,-422));
	if ( RM0 != None )
	{
		RM0.RadiusRange=500;
		RM0.TimePush=3.000000;
		RM0.NamedActor="PathNode3";
		RM0.Tag='';
		RM0.bEnabled = True;
		RM0 = None;
	}
	RM1 = Spawn(class'RadiusMove',,,vect(16,2400,-359));
	if ( RM1 != None )
	{
		RM1.RadiusRange=600;
		RM1.TimePush=1.500000;
		RM1.NamedActor="PathNode1";
		RM1.Tag='';
		RM1.bEnabled = True;
		RM1 = None;
	}
*/
}

final function ChangeNastyActors()
{
	local Actor A;

	foreach AllActors(class 'Actor', A)
	{
		if (string(A.Name) ~= "PrecipitationGenerator0") //No purpose in Net Game being crapped in skybox
		{
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.000000;
			A.SetPropertyText("CoverageY","20"); //Put these or... ?
			A.SetPropertyText("CoverageX","20");
			A.Lifespan = 0.01; //Nope... shedule the TimedBomb...
			log (A.Name$" has been found.",'Kroogar');
			continue;
		}
		if (string(A.Name) ~= "PrecipitationGenerator1")
		{
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.800000;
			A.SetPropertyText("CoverageRadius","1800"); //Fixing ?
//			A.LifeSpan = 0.01; //Maybe... the only map still using it...
			log (A.Name$" has been found.",'Kroogar');
			continue;
		}
		if (string(A.Name) ~= "Counter0") //This looks really stupid
		{
			Counter(A).CountMessage = "%i more to open the door.";
			continue;
		}
/*
		if (string(A.Name) ~= "ZoneInfo3")
		{
			ZoneInfo(A).ZoneName = "Zone Treatment Nitrogen";
			continue;
		}
*/
//Wrong choice --
		if (string(A.Name) ~= "Mover57") 
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover63")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
//---
//Align triggering according to A.I. without affecting humans ---
		if (string(A.Name) ~= "Trigger32")
		{
			Trigger(A).RepeatTriggerTime = 6.500000;
			Trigger(A).ReTriggerDelay = 6.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger40")
		{
			A.InitialState = 'NormalTrigger'; //Nah, not going to mock this
			A.Tag = '';
			Trigger(A).RepeatTriggerTime = 6.500000;
			Trigger(A).ReTriggerDelay = 6.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover33")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover46")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover53")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover59")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}

		if (string(A.Name) ~= "Mover24")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover49")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger35")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover62")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover54")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger33")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover32")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover56")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger37")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover22")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover23")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger8")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover51")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover52")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger36")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover34")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover18")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger18")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover19")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover20")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger34")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}

		if (string(A.Name) ~= "Mover38")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover39")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger23")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
//---
// Another timed aligners
		if (string(A.Name) ~= "Trigger20")
		{
			Trigger(A).RepeatTriggerTime = 8.500000;
			Trigger(A).ReTriggerDelay = 8.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger21")
		{
			Trigger(A).bTriggerOnceOnly = True;
			continue;
		}
		if (string(A.Name) ~= "Trigger27")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover21")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "CreatureFactory1")
		{
			CreatureFactory(A).AddedCoopCapacity = 0; //Useless in MH after all
			continue;
		}
//Timing a la 2017 ---
		if (string(A.Name) ~= "Mover65")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover66")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger3")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover6")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover7")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger15")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover69")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover70")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger29")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover67")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover68")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger28")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
// Spelling ---
		if (string(A.Name) ~= "MonsterEvent4")
		{
			MonsterEvent(A).Message = "The doors to the nitrogen treatment are opened.";
			continue;
		}
// ---
// Again next doors combo --- Not gonna see bot skating here forever anymore :|
		if (string(A.Name) ~= "Mover40")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover41")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger22")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover42")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover43")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger24")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover44")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover45")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger25")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover2")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover3")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger12")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover0")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover1")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger11")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover4")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover5")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger9")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover8")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover9")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger10")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
		if (string(A.Name) ~= "MonsterWaypoint9")
		{
			A.SetLocation(vect(9487,12928,-242)); //Won't be over water... Get On THE GROUND!
			continue;
		}
//--- Make timing
		if (string(A.Name) ~= "Trigger5")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
//---
// Other combo ---
		if (string(A.Name) ~= "Mover14")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover15")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger6")
		{
			Trigger(A).RepeatTriggerTime = 5.500000;
			Trigger(A).ReTriggerDelay = 5.500000;
			continue;
		}
// Final Combo ---
		if (string(A.Name) ~= "Mover12")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover13")
		{
			A.InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Trigger7")
		{
			Trigger(A).RepeatTriggerTime = 19.000000;
			Trigger(A).ReTriggerDelay = 19.000000;
			continue;
		}
// ---
		if (string(A.Name) ~= "MonsterEvent3")
		{
			MonsterEvent(A).Message = "Good job ! You have beat the Skaarj King and break the generator, now you can escape with a ship !";
			continue;
		}
		if (string(A.Name) ~= "MonsterEvent0")
		{
			MonsterEvent(A).Message = "The doors of the Reseach Labo have been opened...";
			continue;
		}
		if (string(A.Name) ~= "MonsterEvent1")
		{
			MonsterEvent(A).Message = "First door to Docks Area is now open.";
			continue;
		}
		if (string(A.Name) ~= "MonsterEvent2")
		{
			MonsterEvent(A).Message = "Second door to docks area is now open.";
			continue;
		}
	}
}

final function SpawnPaths()
{
	if ( G != None )
	{
	}
	Spawn(class'FSmartNode',,,vect(64,5392,-224));
	Spawn(class'SmartNode',,,vect(-106,5696,-223));
	Spawn(class'SmartNode',,,vect(-190,5896,-291));
	Spawn(class'SmartNode',,,vect(7632,6680,-96));
	Spawn(class'SmartNode',,,vect(7576,7416,-96));
	Spawn(class'FSmartNode',,,vect(64,5392,-224));
	Spawn(class'SmartNode',,,vect(7439,14312,-224));
	Spawn(class'FSmartNode',,,vect(7144,14304,-224));
	Spawn(class'SmartNode',,,vect(7810,14300,-224));
	Spawn(class'FSmartNode',,,vect(8152,14320,-224));
}

function RestoreOriginal()
{
	local Actor A;
}

function DoReconnect()
{
	local NavigationPoint N;
	local ZoneInfo Z;
}

auto state PathsMapping
{
Begin:
	Sleep(0.2);
	log ("Navigation processing done, spawning new paths...",'GXech');
	SpawnPaths();
	Spawn(class'SomeActor');
	Sleep(0.0);
	DoFakeNavigation();
//	HackedZone.SetPropertyText("bWaterZone","False");
Sleep(0.5);
	DoReconnect();
//	Spawn(class'TelPathsHacker');
	RestoreOriginal();
	GotoState('');
}

defaultproperties
{
	bMovable=False
	bStatic=False
	bGameRelevant=True
}
